package org.security.common.util;

import cn.hutool.core.codec.Base64;
import com.google.zxing.BarcodeFormat;
import com.google.zxing.EncodeHintType;
import com.google.zxing.MultiFormatWriter;
import com.google.zxing.common.BitMatrix;
import org.springblade.core.tool.utils.Func;

import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.ByteArrayOutputStream;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * @author Create by wzf
 * @date 2022/5/7 16:35
 * 二维码生成工具
 */
public class QrCodeUtil {

	/**
	 * 生成二维码
	 * @param qrCodeId 设备id
	 * @return
	 */
	public static String createQrCode(String qrCodeId){
		// 二维码需要使用到的颜色
		final int BLACK = 0xFF000000;
		final int WHITE = 0xFFFFFFFF;
		String base64 = "";
		// 需要生成的二维码的文字、地址
		String qrCodeStr = qrCodeId.concat("-").concat(Func.formatDateTime(new Date()));
		// 创建二维码
		try {
			Map<EncodeHintType, String> charcter = new HashMap<>();
			// 设置字符集
			charcter.put(EncodeHintType.CHARACTER_SET, "UTF-8");
			// 设置二维码的四个参数   需要生成的字符串，类型设置为二维码，二维码宽度，二维码高度，字符串字符集
			BitMatrix bitMatrix = new MultiFormatWriter()
				.encode(qrCodeStr, BarcodeFormat.QR_CODE, 500, 500, charcter);
			// 二维码像素，也就是上面设置的 500
			int width = bitMatrix.getWidth();
			int height = bitMatrix.getHeight();
			// 创建二维码对象
			BufferedImage image = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
			for (int x = 0; x < width; x++) {
				for (int y = 0; y < height; y++) {
					// 按照上面定义好的二维码颜色编码生成二维码
					image.setRGB(x, y, bitMatrix.get(x, y) ? BLACK : WHITE);
				}
			}
			// 1、第一种方式
			// 生成的二维码图片对象转 base64
			ByteArrayOutputStream stream = new ByteArrayOutputStream();
			// 设置图片的格式
			ImageIO.write(image, "png", stream);
			// 生成的二维码base64
			base64 = Base64.encode(stream.toByteArray());
		} catch (Exception e) {
			e.printStackTrace();
		}
		return base64;
	}
}
